<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { onBeforeMount, ref, watch, inject } from 'vue';
import { storeToRefs } from 'pinia';
import Modal from '@/components/general/Modal.vue';
import Input from '@/components/general/form/Input.vue';
import TextEditor from '@/components/general/form/TextEditor.vue';
import UploadDropArea from '@/components/general/form/UploadDropArea.vue';
import ImageCropper from '@/components/general/ImageCropper.vue';
import Stepper from '@/components/general/Stepper.vue';
import Switch from '@/components/general/form/Switch.vue';
import CheckboxGroup from '@/components/general/form/CheckboxGroup.vue';
import { request } from '@/lib/request';
import { useChatStore } from '@/stores/chat';
import { useI18n } from 'vue-i18n';
import RadioButtonsGroup from "@/components/general/form/RadioButtonsGroup.vue";
import { useBaseStore } from '@/stores/base';

const { t } = useI18n();
const $t = t;
const chatStore = useChatStore();
const baseStore = useBaseStore();
const { state, uuid } = storeToRefs(chatStore);
const { message } = storeToRefs(baseStore);
const openAccordionElement = ref('base');
const configuration = inject<any>('configuration');

const emits = defineEmits<{
    (e: 'submit'): void,
    (e: 'close'): void
}>();

onBeforeMount(async () => {
    if (state.value === 'PERSON_EDIT' && uuid.value && uuid.value.length > 0) {
        const result = await request('GET', configuration.apiServer + "/api/ai/person/" + uuid.value, undefined, undefined, false, true);
        if (result.success) {
            const person = result.person;
            name.value = person.name;
            description.value = person.description;
            shareForEveryone.value = person.shared;
            systemprompt.value = person.system_prompt;
            croppedImage.value = person.avatar ? configuration.apiServer + person.avatar : null;
            category.value = person.categories[0]!==null?person.categories:[];
        }
        else {
            emits('close');
        }
    };
});

const handleSubmit = async () => {
    const formData = new FormData();
    formData.append('name', name.value);
    formData.append('systemprompt', systemprompt.value);
    formData.append('model', model.value);
    formData.append('description', description.value);
    formData.append('shared', JSON.stringify(shareForEveryone.value));
    formData.append('categories', JSON.stringify(category.value));
    if (state.value === 'PERSON_CREATE') {
        if(croppedImage.value!==null)
            formData.append('file', croppedImage.value);
        const result = await request('PUT', configuration.apiServer + "/api/ai/person/", formData, 'multipart/form-data', false, true);
        if (result.success) emits('submit');
    } else if (state.value === 'PERSON_EDIT' && uuid.value && uuid.value.length > 0) {
        if (croppedImage.value && (!croppedImage.value.includes('http://') && !croppedImage.value?.includes('https://')))
            formData.append('file', croppedImage.value);
        const result = await request('POST', configuration.apiServer + "/api/ai/person/" + uuid.value, formData, 'multipart/form-data', false, true);
        if (result.success){
            message.value = $t('ai.general.variables.notification.update.success'); 
            emits('submit');
        }
    }
};

const handleCancel = () => {
    emits('close');
};

const name = ref('');
const systemprompt = ref('');
const description = ref('');
const file = ref();
const fileContent = ref();
const croppedImage = ref<string | null>(null);
const shareForEveryone = ref(false);
const category = ref([]);
const avatar = ref();


const handleSetCroppedImage = (value: string) => {
    croppedImage.value = value;
};

const isImageCropperModalOpen = ref(false);
watch(() => file.value, (newVal, oldVal) => {
    const reader = new FileReader();
    reader.onload = (e: any) => {
        fileContent.value = e.target.result;
    };
    reader.readAsDataURL(newVal);
    isImageCropperModalOpen.value = true;
});

const handleCloseImageCropperModal = () => {
    isImageCropperModalOpen.value = false;
};

const handleCancelImageCropperModal = () => {
    croppedImage.value = null;
    handleCloseImageCropperModal();
};

const deleteImage = ref(false);
const handleDeleteCroppedImage = () => {
    croppedImage.value = null;
    deleteImage.value = true;
};

const stepperSteps = [{ label: $t('ai.person.create.base.label'), name: 'base', icon: 'ri-info-i' },
{ label: $t('ai.person.create.additionalFields.label'), name: 'description', icon: 'ri-settings-3-line' }];

const options = configuration.ai.personCategories;

const localModels = configuration.ai.models.chat.filter((item:any)=>{if('canSystemPrompt' in item && item.canSystemPrompt === true) return item; return undefined}).sort((a: { label: string, value: string }, b: { label: string, value: string }) => {
    if (a.label < b.label) {
        return -1;
    }
    if (a.label > b.label) {
        return 1;
    }
    return 0;
}).map((item: { label: string, value: string }) => { return { name: item.value, label: item.label }; });
const model = ref(localModels[0].name);

</script>
<template>
    <Modal
        :header="state === 'PERSON_EDIT' ? $t('ai.person.create.title.edit.label') : $t('ai.person.create.title.create.label')"
        :labelSubmit="$t('general.buttons.save')" :labelCancel="$t('general.buttons.cancel')" @submit="handleSubmit"
        @cancel="handleCancel" :disableSubmit="name.length === 0 && systemprompt.length === 0">
        <div class="mt-4 flex flex-col gap-2">
            <Stepper v-model:active="openAccordionElement" :steps="stepperSteps" />
            <div class="flex flex-col gap-1" v-if="openAccordionElement === 'base'">
                <Input v-model="name" :label="$t('ai.person.create.name.label')" type="text"
                    :placeholder="$t('ai.person.create.name.placeholder')" />
                <div>
                    <CheckboxGroup v-model="category" :options="options" :label="$t('ai.person.create.category.label')" :info="$t('ai.person.create.category.tooltip')"/>
                </div>
                <RadioButtonsGroup v-model="model" :label="$t('ai.chat.create.model.label')" :items="localModels" 
                    columns v-if="state === 'PERSON_CREATE'"/>
                <div class="flex flex-col gap-1">
                    <label class="flex flex-row gap-2">{{ $t('ai.person.create.systemprompt.label') }}<Tooltip
                            :tooltip="$t('ai.person.create.systemprompt.tooltip')"><i
                                class="ri-information-2-line cursor-pointer"></i></Tooltip></label>
                    <textarea
                        class="border border-gray-300 rounded-md resize-none p-2 text-gray-500 focus:outline-none focus-within:outline-none"
                        maxlength="4000" rows="5" v-model="systemprompt"
                        :placeholder="$t('ai.person.create.systemprompt.placeholder')"></textarea>
                    <div class="text-right text-gray-500"> {{ systemprompt.length }} / 4000</div>
                    <Switch v-model="shareForEveryone" :label="$t('ai.person.create.share.label')"
                        :header="$t('ai.person.create.share.header')" />
                </div>
            </div>
            <div v-if="openAccordionElement === 'description'">
                <div class="flex flex-col gap-1">
                    <div>
                        <label>{{ $t('ai.person.create.image.label') }}</label>
                        <div class="text-gray-500" v-if="!croppedImage">
                            <UploadDropArea v-model="file" :error="$t('ai.person.create.image.error')"
                                accept=".png,.jpeg,.jpg" :fileSize="5000000" />
                        </div>
                        <div class="w-full inline-flex flex-row justify-center" v-else>
                            <div class="size-40 relative">
                                <img class="object-contain m-auto w-full" :src="croppedImage" v-if="croppedImage"/>
                                <button
                                    class="bg-gray-100 hover:bg-gray-200 rounded-full size-8 absolute -top-5 -right-5 text-2xl text-red-700"
                                    @click="handleDeleteCroppedImage">
                                    <i class="ri-delete-bin-line"></i>
                                </button>
                            </div>
                        </div>
                    </div>
                    <div>
                        <label>{{ $t('ai.person.create.description.label') }}</label>
                        <div
                            class="border border-gray-300 rounded-md resize-none p-2 text-gray-500 focus:outline-none focus-within:outline-none h-40 max-h-40">
                            <TextEditor hideButtons v-model="description" />
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <Modal :header="$t('ai.person.create.image.modal.header')" v-if="isImageCropperModalOpen"
            :labelSubmit="$t('ai.person.create.image.modal.submit.label')" :labelCancel="$t('general.buttons.cancel')"
            @cancel="handleCancelImageCropperModal" @submit="handleCloseImageCropperModal">
            <p>{{ $t('ai.person.create.image.modal.description') }}</p>
            <ImageCropper @change="handleSetCroppedImage" :image="fileContent" />
        </Modal>
    </Modal>
</template>
